unit hiBASS_Global;

interface

uses Windows,Kol,Share,Debug,Dynamic_BASS;

type
  THIBASS_Global = class(TDebug)
   private
    procedure Search(const Dir:string);
       procedure Err;
          public
    _prop_Device:integer;
    _prop_Freq:integer;
    _prop_Name:string;
    _prop_PlugsDir:string;

    _data_Freq:THI_Event;
    _data_Device:THI_Event;
    _data_Name:THI_Event;
    _data_PlugsDir:THI_Event;
    
    _event_onError:THI_Event;
    _event_onSearch:THI_Event;
    
    procedure _work_doLoad(var _Data:TData; Index:word);
    procedure _work_doUnload(var _Data:TData; Index:word);
    procedure _work_doInit(var _Data:TData; Index:word);
    procedure _work_doStart(var _Data:TData; Index:word);
    procedure _work_doPause(var _Data:TData; Index:word);
    procedure _work_doStop(var _Data:TData; Index:word);
  end;

implementation

procedure THIBASS_Global.Err;
begin
   if BASS_ErrorGetCode > 0 then
    _hi_OnEvent(_event_onError,integer(BASS_ErrorGetCode));
end;

procedure THIBASS_Global._work_doLoad;
var Dr:String;
begin
    Load_BASSDLL(ReadString(_Data,_data_Name,_prop_Name));
    Dr := ReadString(_Data,_data_PlugsDir,_prop_PlugsDir);
    Search(Dr);
end;

procedure THIBASS_Global.Search;
var FH:THandle;
    FD: TWin32FindData;
    Plug: HPLUGIN;
    Info: ^Bass_PluginInfo;
  s: string;
  a: integer;
  begin
  FH := FindFirstFile(PChar(Dir + '\' + 'bass*.dll'), FD);
  if (FH <> INVALID_HANDLE_VALUE) then
  try
    repeat
      Plug := BASS_PluginLoad(PChar(Dir + '\' + FD.cFileName), 0);
      if Plug <> 0 then
      begin
        Info := pointer(BASS_PluginGetInfo(Plug));
        for a := 0 to Info.formatc - 1 do
        begin
          if (Info.Formats[a].name <> nil) then
            if (a = 0) then
              s :=Info.Formats[a].name
            else
              s := s + ',' + Info.Formats[a].name;
        end;
      _hi_OnEvent(_event_onSearch,string(FD.cFileName) + ',' + (s));
      end;
    until FindNextFile(FH, FD) = false;
  finally
    FindClose(FH);
  end; 
end;

procedure THIBASS_Global._work_doUnload;
begin
    BASS_PluginFree(0);
    Unload_BASSDLL;
  //Err;
end;

procedure THIBASS_Global._work_doInit;
begin
   BASS_Init(ReadInteger(_Data,_data_Device,_prop_Device),ReadInteger(_Data,_data_Freq,_prop_Freq),
    0,ReadHandle,nil);
  Err;
end;

procedure THIBASS_Global._work_doStart;
begin
     BASS_Start;
  Err;
end;

procedure THIBASS_Global._work_doPause;
begin
  BASS_Pause;
  Err;
end;

procedure THIBASS_Global._work_doStop;
begin
  BASS_Stop;
  Err;
end;

end.
